/*
 *  Copyright (C) 1997, 1998 Olivetti & Oracle Research Laboratory
 *
 *  This is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 *  USA.
 *
 *  Seriously modified by Fredrik Hbinette <hubbe@hubbe.net>
 *  Modified yet again by Tom Rothamel <tom-vnc@onegeek.org> for vncwhap
 *  and vncscript.
 */


#include <x2vnc.h>
#include <time.h>
#include <stdlib.h>

void vncwait(int length) {
	fd_set fds;
	struct timeval tv;
	
	do {
			    
		tv.tv_sec = 0;
		tv.tv_usec = length * 1000;
		
		FD_ZERO(&fds);
		FD_SET(rfbsock,&fds);
		
		if (select(FD_SETSIZE, &fds, NULL, NULL, &tv) < 0) {
			exit(1);
		}
		
		if (FD_ISSET(rfbsock, &fds)) {
			if (!HandleRFBServerMessage()) {
				exit(1);
			}
		}
	} while (tv.tv_usec);
}

	    
int main(int argc, char **argv) {
	FILE *script = stdin;	
	
	srand(time(NULL));
    
	processArgs(argc, argv);

	if (!ConnectToRFBServer(hostname, port)) exit(1);
	if (!InitialiseRFBConnection(rfbsock)) exit(1);

	if (!SetFormatAndEncodings()) {
		exit(1);
	}

	if (scriptFile) {
		script = fopen(scriptFile, "r");
		if (!script) {
			fprintf(stderr, "Script file not found.\n");
			return -1;
		}
	}

	yyin = script;
	yylex();	
    
	return 0;
}
